<?php

/*ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);*/

date_default_timezone_set("Europe/Zurich");

$debug = false;

include_once($_SERVER['DOCUMENT_ROOT'].'/inc/origin.class.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/config.php');

originHelper\origin::check($config['allowed-origins']);

$allowedIP = $config['local-ip'];
if(!($_SERVER['REMOTE_ADDR'] == $allowedIP)) {
  header('X-CacheStatus: private');
  header('Content-Type: application/json');
  die('[]');
}

include_once("inc/caldav/caldav-client.php");
include_once("inc/caldav/ical-event.php");
include_once('inc/caldav/carbon/autoload.php');
include_once("inc/caldav/ical.php");


$from = new DateTime();
$to = new DateTime();
$to->add(new DateInterval($config['calendar-interval']));


$user = $config['calendar-user'];
$token = $config['calendar-token'];

$baseurl = $config['calendar-url'];

$what = get('c','');


$cals = $config['calendar-known-calendars'];
$cal = null;

if(array_key_exists($what, $cals)) {
  $cal = $cals[$what];
} else {
  die("{'err':'not found'}");
}

$cachePre = 'cache/.calendar';
$cachePost = '.cache';
$cacheAge = 10800;

$file = $cachePre.$what.$cachePost;
$ret = "";
$fileage = @filemtime($file);
//caching
if($fileage && !(time() - $fileage >= $cacheAge) && !$debug) {
  header('X-CacheStatus: cached');
  header('X-CacheAge: '.(time() - $fileage));
  $ret = file_get_contents($file);
}
if($ret == "") {
  header('X-CacheStatus: fresh');
  $events = getEvents($baseurl.$cal['rel'],$user,$token,$from,$to, $cal['label']);
  $ret = json_encode($events);
  file_put_contents($file, $ret);
}
header('Content-Type: application/json');
echo $ret;

function getEvents($url, $user, $token, $from, $to, $calendar) {
  global $debug;
  $ret = [];
  $cal = new CalDAVClient($url, $user, $token);
  $cal->SetDepth(1);
  $events = $cal->GetEvents($from->format("Ymd\THis\Z"),$to->format("Ymd\THis\Z"));
  foreach($events as $k => $event) {
    if($debug) {
      echo "DEBUG1: ".$event['data'];
    }
    $evt = new ICal\ICal(false, array('defaultTimeZone'=>'Europe/Zurich', 'useTimeZoneWithRRules'=>true));
    $evt->initString($event['data']);
    if($debug) {
      foreach($evt->events() as $e) {
        echo "DEBUG2: ".$e->dtstart." - ".$e->dtend."\n";
      }
    }
    foreach ($evt->eventsFromRange($from->format('Y-m-d H:i:s'), $to->format('Y-m-d H:i:s')) AS $m) {
      //$ret[] = ['from'=>date('d.m H:i',$m->dtstart_array[2]), 'to'=>date('H:i',$m->dtend_array[2]), 'summary'=>$m->summary];
      //$evfrom = new DateTime(); $evfrom->setTimestamp(strtotime($m->dtstart));
      //$evto = new DateTime(); $evto->setTimestamp(strtotime($m->dtend));
      if($debug) {
        echo "DEBUG3: ".$m->dtstart." - ".$m->dtend."\n";
      }
      $ret[] = ['start'=>date("c", strtotime($m->dtstart)), 'end'=>date("c", strtotime($m->dtend)), 'title'=>$m->summary, 'id'=>$m->uid, 'editable'=>false];
    }
  }
  return $ret;
}

function get($key, $defaultValue = '') {
  return isset($_GET[$key]) ? $_GET[$key] : $defaultValue;
}
