<?php
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/origin.class.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/config.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/funcs.php');

originHelper\origin::check($config['allowed-origins']);

$baseurl = $config["location-url"];
$points = $config["locations"];
$pois = $config["location-poi"];

$ret = [];

function getPoint($baseurl, $url) {
	global $pois;
	//assumption: home location is at $pois[0]
  $homeLat = $pois[0]["lat"];
  $homeLon = $pois[0]["lon"];

  $cache = "./cache/.$url.cache";
  try {
    $point = json_decode(apiFuncs\cache_contents($baseurl.$url, $cache, 43200, true), true);
    $ret = $point[$url];
    $key = array_keys($ret)[0];
    $ret = $ret[$key];
    $dt = new DateTime();
    $dt->setTimestamp($ret["timestamp"]);
  } catch(Exception $ex) {
    $now = new DateTime();
    return ["name"=>"Error", "date"=>$now->format("c"), "error"=>$ex->getMessage()];
  }

  $distPoi = [];
  $poi = "";
  foreach ($pois as $poii) {
    $poiDist = vincentyGreatCircleDistance($poii["lat"],$poii["lon"],$ret["lat"],$ret["lon"]);
    $distPoi[] = ["dist"=>$poiDist, "label"=>$poii["label"]];
    if($poiDist < 0.3) {
      $poi = $poii["label"];
    }
  }

  return ["name"=>$key, "timestamp"=>$ret["timestamp"], "date"=>$dt->format("c"), "lat"=>$ret["lat"], "lon"=>$ret["lon"],
  "accuracy"=>$ret["accuracy"], "battery"=>$ret["batterylevel"],
"distance"=>vincentyGreatCircleDistance($homeLat, $homeLon, $ret["lat"], $ret["lon"]), "poi"=>$poi /*, "debug"=>$distPoi*/ ];
}

foreach($points as $point) {
  $ret[] = getPoint($baseurl,$point);
}

//source: https://stackoverflow.com/questions/10053358/measuring-the-distance-between-two-coordinates-in-php
function vincentyGreatCircleDistance($latitudeFrom, $longitudeFrom, $latitudeTo, $longitudeTo, $earthRadius = 6371) {
  // convert from degrees to radians
  $latFrom = deg2rad($latitudeFrom);
  $lonFrom = deg2rad($longitudeFrom);
  $latTo = deg2rad($latitudeTo);
  $lonTo = deg2rad($longitudeTo);

  $lonDelta = $lonTo - $lonFrom;
  $a = pow(cos($latTo) * sin($lonDelta), 2) + pow(cos($latFrom) * sin($latTo) - sin($latFrom) * cos($latTo) * cos($lonDelta), 2);
  $b = sin($latFrom) * sin($latTo) + cos($latFrom) * cos($latTo) * cos($lonDelta);

  $angle = atan2(sqrt($a), $b);
  return round($angle * $earthRadius,1);
}


header('Content-Type: application/json');
echo json_encode($ret);
