<?php
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/origin.class.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/config.php');
include_once($_SERVER['DOCUMENT_ROOT'].'/inc/funcs.php');

originHelper\origin::check($config['allowed-origins']);

$feed = "https://www.regioterre.sg/category/aktuelle-tasche/feed/";
$cache = "cache/.regioterre.cache";

header('Content-Type: application/json');

try {
  $content = apiFuncs\cache_contents($feed, $cache, 43200, true);  // 10800 = 3 Stunden, 43200 = 12 Stunden, 86400 = 24 Stunden
} catch (Exception $ex) {
  $arr = [];
  $arr[] = "Fehler beim Abrufen der regioterre Webseite!";
  $arr[] = $ex->getMessage();
  die(json_encode(["texts"=>$arr, "alltext"=>""]));
}
$x = new SimpleXmlElement($content);
  
$today = new DateTime();


$ret = [];
$alltext = '';
foreach($x->channel->item as $entry) {
  $date = new DateTime($entry->pubDate);
  if($date->diff($today)->days < 4) {
		$desc = (string)$entry->description;
		$desc = str_replace("&nbsp;", " ", $desc); // non-breaking space
		$desc = str_replace("&#160;", " ", $desc); // non-breaking space
		$desc = html_entity_decode($desc);
		//$ret[] = ["text"=>"debug vorher: ".$desc];
    if(preg_match('/[Kk]?leine Taschen?;?:?([^;:]*)[;:]?.*[Gg]rosse Taschen?;?:?[^;]*;?\s?(.*)?/', $desc, $matches)) {
      $line = $matches[1];
      $arr = explode(", ", $line);
      foreach($arr as $itm) {
				$tmp = $itm;
				if(endsWith($tmp, " mittlere Tasche")) {
					$tmp = substr($tmp,0,strlen($tmp)-16);
				}
        $ret[] = ["text"=>$tmp];
      }
      if(count($matches) > 2) {
        if( ! preg_match('/^([zZ]usatzabo:?\s?)?\\(.*\\)$/', $matches[2], $matches2)) {
          $alltext = $matches[2];
        } else {
          $alltext = '';
        }
      } else {
        $alltext = $desc;
      }
    } else {
			if(preg_match('/[Kk]?leine Taschen?;?:?([^;:]*)[;:]?.*/', $desc, $matches)) {
				$line = $matches[1];
				$arr = explode(", ", $line);
				foreach($arr as $itm) {
					$ret[] = ["text"=>$itm];
				}
			} else {
				if(preg_match('/((.+)[;])\s?(.*)?/', $desc, $matches)) {
					$line = $matches[2];
					$arr = explode(", ", $line);
					foreach($arr as $itm) {
						$ret[] = ["text"=>$itm];
					}
					if(count($matches) > 3) {
						if( ! preg_match('/^\\(.*\\)$/', $matches[3], $matches3)) {
							$alltext = $matches[3];
						} else {
							$alltext = '';
						}
					} else {
						$alltext = $desc;
					}
				} else {
					$ret[] = ["text"=>$desc];
				}
      }
    }   
  }
}
echo json_encode(["texts"=>$ret, "alltext"=>$alltext]);

function endsWith($string, $endString) 
{
    $len = strlen($endString);
    if ($len == 0) {
        return true;
		}
		if(strlen($string) < $len) {
			return false;
		}
    return (substr($string, -$len) === $endString);
}
