<?php
include_once($_SERVER['DOCUMENT_ROOT'] . '/inc/funcs.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/inc/config.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/inc/Ntfy.php');

use ApiMayerLife\Ntfy;

$debug = true;
if (isset($_GET["c"]) && $_GET["c"] == "1") {
	$debug = false;
}
$sinceDate = $config['gogs-last-date'];

$commitsUrl = "https://api.github.com/repos/gogs/gogs/commits";
$files = array(
	"/templates/base/head.tmpl",
	"/templates/base/footer.tmpl",
	"/templates/repo/home.tmpl",
	"/templates/repo/bare.tmpl",
	"/templates/status/404.tmpl",
);


if ($debug) {
	echo '<!doctype html>
<html>
  <head>
    <title>gogs changes</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="//gma.name/css/bootstrap.darkly.v520.min.css">
  </head>
  <body>
    <div class="container">

      <nav class="navbar navbar-dark bg-primary mb-3 px-2">
        <a class="navbar-brand" href="/">api.mayer.life</a>
        <span class="navbar-text text-light mb-0 h5" style="width:75%;text-align:center;">gogs changes</span>
      </nav>

			<div class="card-columns">';
}

$sinceParam = $sinceDate->format('c');


$hasOutput = false;
$pushMsg = '';

foreach ($files as $f) {
	$needsHeader = true;
	$pushFile = '';
	$url = $commitsUrl . "?path=" . $f . "&since=" . $sinceParam;
	$commits = json_decode(apiFuncs\xsget($url));
	if (is_array($commits)) {
		foreach ($commits as $e) {
			$dt = new DateTime($e->commit->author->date);
			if ($needsHeader && $debug) {
				echo "<div class=\"card border-info mb-3\">\n";
				echo "<div class=\"card-header\">" . $f . "</div>\n";
				$needsHeader = false;
			}
			if ($debug) {
				echo "<div class=\"card-body\">\n";
				echo "<p class=\"card-text\">" . $e->commit->message . "\n<br></p>";
				echo "<a class=\"btn btn-lg btn-info\" role=\"button\" href=\"" . $e->html_url . "\" title=\"View commit\">View commit</a>";
				echo "</div><div class=\"card-footer\"><small class=\"text-muted\">" . $dt->format("d.m.y H:i:s") . "</small></div>";
			} else {
				$pushFile = $f;
			}
			$hasOutput = true;
		}
		if (!$debug && $pushFile !== '') {
			if ($pushMsg == '') {
				$pushMsg = "The following gogs templates have changes:  \n";
			}
			$pushMsg .= "- $f  ";
		}
	}
	if (!$needsHeader && $debug) {
		echo "</div>";
	}
}
if ($hasOutput == false && $debug) {
	echo "<div class=\"card border-success mb-3\">\n";
	echo "<div class=\"card-header\">Nothing changed</div>\n";
	echo "<div class=\"card-body\">\n";
	echo "nothing changed since " . $sinceDate->format("d.m.y H:i");
	echo "</div></div>";
}

if (($debug == false) && $pushMsg !== '') {
	$push = new Ntfy($config['ntfy-topic'], $config['ntfy-token']);
	$pushMsg .= "\n\n[details](https://api.mayer.life/gogs/check_gogs_changes.php)";
	if ($push->publish("gogs template changed", $pushMsg)) {
		print "++OK";
	} else {
		print "--ERROR";
	}
}

if ($debug) {
	echo '</div>
</div>
</body>
</html>';
}
