<?php
$config = array(
  'local-ip' => '192.168.1.1', // ip-address of router (this identifies an "internal" user that 'sees' the calendar entries. All other ip-addresses see a empty list.)
  'allowed-origins' => array('https://example.com', 'https://example.org'), // allowed origin of requests to the api. This should be set to the URLs you will be using the dashboard/

  'weather-api' => '777777777777777', // obsolete -- api key for openweathermap.org - see their documentation.
  'weather-location' => 'St.+Gallen,ch', // obsolete -- location for weather forecast (url-encoded)
  'weather-lat' => '47.5', // latitude for weather
  'weather-lon' => '9.2', // longitude for weather
  'weather-alt' => '350', // altitude (meters above sea) for weather

  'calendar-interval' => 'P7D', // show entries from today, [plus 7 days]
  'calendar-user' => 'user', // user for nextcloud calendar
  'calendar-token' => 'sEcReTPasswoRd', // app-password for nextcloud calendar
  'calendar-url' => "https://my-nextcloud-server.local/remote.php/dav/calendars/", // base url for webdav calendars
  'calendar-known-calendars' => array(
    'a' => array('rel' => "user/personal/", 'label' => "Default calendar"),
    'b' => array('rel' => "user/calendar-b/", 'label' => "Calendar B"),
    'c' => array('rel' => "user/personal_shared_by_otheruser/", 'label' => "Shared by OtherUser") // take the URLs from nextcloud calendar settings
  ),

  'transport-stations' => array("Zürich HB", "Zürich Flughafen"), // multiple stations or just one.
  'transport-num-per-station' => 5, // if you define just one station make sure this matches the below number. The more stations you define the less connections you need per station.
  'transport-num-results' => 6, // maximum number of future connections to return

  'gotify-url' => "https://gogs-server/message",
  'gotify-token' => "token-from-gotify",
  'gogs-last-date' => new DateTime('2020-01-01 00:00:00'),

  'ntfy-token' => "aaabbbcccc",
  'ntfy-topic' => "notification",

  'gotify-token-workout' => "token-from-gotify-for-workout",
  'workout' => array( // workout plan. Includes description, start date, interval in days (f.E. repeats every 6 days), workout days (f.E. interval=6, workout=4 ==> 4 days workout, 2 days rest),
    // repetitions: either integer or array(startDay, startReps, midDay, midReps, endDay, endReps)
    array('desc' => 'Liegestützen', 'start' => new DateTime('2022-01-01'), 'interval' => 6, 'workout' => 4, 'reps' => 6), // example: plan starts on January 1st with 4 days of workout and 2 days rest, 6 repetitions.
    array('desc' => 'Rumpfbeugen', 'start' => new DateTime('2022-01-02'), 'interval' => 5, 'workout' => 4, 'reps' => array(0, 10, 15, 20, 50, 44)), // example: plan starts on January 2nd with 4 days of workout and 1 day of rest, repetitions start with 10, at day 15 with 20 repetitions and ends at day 50 with 44 repetitions.
  ),

  'location-url' => "https://my-nextcloud-server.local/apps/phonetrack/api/getlastpositions/", // base url of phonetrack api
  'locations' => array("1234567890abcdef1234567890abcdef"), // array of points to show on map
  'location-poi' => array(
    array('lat' => 47.5, 'lon' => 9.2, 'label' => 'Home'), // assumption: first poi is home
    array('lat' => 47.4, 'lon' => 9.3, 'label' => 'Work'), // further named locations to display instead of "distance from home"
  ),

);
