<?php

namespace originHelper {
  class origin
  {
    public static $current = '';

    public static function check(array $allowedOrigins)
    {
      if (isset($_SERVER["HTTP_ORIGIN"])) {
        $org = $_SERVER["HTTP_ORIGIN"];
        if (str_ends_with($org, "/")) {
          $org = \rtrim($org, "/");
        }
        if (\in_array($org, $allowedOrigins)) {
          \header("Access-Control-Allow-Origin: " . $_SERVER["HTTP_ORIGIN"]);
          \header("Access-Control-Max-Age: 86400");
        } else {
          exit(0);
        }
        if ($_SERVER['REQUEST_METHOD'] == "OPTIONS") {
          if (isset($_SERVER["HTTP_ACCESS_CONTROL_REQUEST_METHOD"])) {
            \header("Access-Control-Allow-Methods: GET, POST, OPTIONS");
          }
          if (isset($_SERVER["HTTP_ACCESS_CONTROL_REQUEST_HEADERS"])) {
            \header("Access-Control-Allow-Headers: " . $_SERVER["HTTP_ACCESS_CONTROL_REQUEST_HEADERS"]);
          }
          exit(0);
        }
        origin::$current = $org;
      }
    }
  }
}
