/* script for t.gma.name by gma */

function isValidIpAddr(ip) {
  // check for valid ipv4 and ipv6 address using regex. source: https://regex101.com/library/yyslXu
  return /((^\s*((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\s*$)|(^\s*((([0-9a-f]{1,4}:){7}([0-9a-f]{1,4}|:))|(([0-9a-f]{1,4}:){6}(:[0-9a-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){5}(((:[0-9a-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9a-f]{1,4}:){4}(((:[0-9a-f]{1,4}){1,3})|((:[0-9a-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){3}(((:[0-9a-f]{1,4}){1,4})|((:[0-9a-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){2}(((:[0-9a-f]{1,4}){1,5})|((:[0-9a-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9a-f]{1,4}:){1}(((:[0-9a-f]{1,4}){1,6})|((:[0-9a-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9a-f]{1,4}){1,7})|((:[0-9a-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$))/.test(ip);
}

function truncate(ip) {
  return ip.length > 20 ? ip.slice(0, 5) + '…' + ip.slice(-20 + 5) : ip;
}

const openIpLink = (event) => {
  const trg = event.target;
  if (trg) {
    if (trg.id === 'ip') {
      return;
    } else {
      const e = document.getElementById('ip');
      e.click();
    }
  }
};

addEventListener('DOMContentLoaded', async () => {
  try {
    const resp = await fetch('/myip');
    const respText = await resp.text();
    const e = document.getElementById('ip');
    if (isValidIpAddr(respText)) {
      e.href = 'https://ipinfo.io/' + respText;
      e.textContent = truncate(respText);
      e.title = respText;
      e.parentNode.onclick = openIpLink;
    } else {
      e.textContent = 'invalid ip.';
      e.title = 'invalid ip.';
    }
  } catch (ex) {
    console.error(ex);
  }
});

addEventListener('load', () => {
  // display document load time
  window.setTimeout(() => {
    if (window && window.performance && window.performance.timing) {
      const perfData = window.performance.timing;
      if (perfData.loadEventEnd && perfData.navigationStart) {
        const loadTime = perfData.loadEventEnd - perfData.navigationStart;
        if (loadTime && loadTime > 0) {
          document.getElementById('load').innerText = loadTime + ' ms';
          return;
        }
      }
    }
    document.getElementById('load').innerText = 'unknown.';
  }, 50);
});

/* Load Webfont */
const wof = document.createElement('link');
wof.rel = 'stylesheet';
wof.href = 'https://gma.name/fonts/opensans.css';
wof.type = 'text/css';
const firstlnk = document.getElementsByTagName('link')[0];
firstlnk.parentNode.insertBefore(wof, firstlnk);
