<!DOCTYPE html>
<html>

<head>
	<meta charset='utf-8' />
	<title>info</title>
	<link type="text/css" rel="stylesheet" href="//gma.name/css/bootstrap.darkly.v520.min.css" />
	<link type="text/css" rel="stylesheet" href="//gma.name/fonts/fa5.min.css" />
</head>

<body>
	<div class='container-fluid'>
		<nav class="navbar navbar-dark bg-primary mb-3 justify-content-center">
			<span class="navbar-text text-light mb-0 h5"><span class="fas fa-info-circle" aria-hidden="true"></span> Server / Client Details</span>
		</nav>

		<div class="row row-cols-1 row-cols-md-2 g-2">
			<?php
			$brotli = 'nope';
			if (isset($_SERVER['HTTP_ACCEPT_ENCODING'])) {
				$encodings = explode(',', strtolower(preg_replace('/\s+/', '', $_SERVER['HTTP_ACCEPT_ENCODING'])));
				if (in_array('br', $encodings)) {
					$brotli = 'yes';
				}
			}

			prh("Server Details", "server");
			prn(getOrEmpty("SERVER_PROTOCOL"), "protocol");
			prn(getOrEmpty('SSL_SERVER_NAME'), "server name");
			prn(getOrEmpty('SSL_PROTOCOL'), "ssl protocol");
			prn(getOrEmpty('SSL_CIPHER'), "ssl cipher");
			prn(getOrEmpty('HTTPS'), 'https');
			prn(isset($_SERVER['SERVER_PROTOCOL']) ? ($_SERVER['SERVER_PROTOCOL'] == "HTTP/2.0" ? "yes" : "no") : 'no', "http2");
			prf();

			prh("Browser Details", "window-maximize");
			prn(getOrEmpty('REMOTE_ADDR'), "ip-address");
			prn((filter_var($_SERVER['REMOTE_ADDR'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV6) ? "IPv6" : "IPv4"), "ip type");
			prn(htmlspecialchars($_SERVER['HTTP_USER_AGENT']), "user agent");
			prn($brotli, "brotli support");
			prf();

			$client = getOrEmpty('CLIENT_CERT_VERIFY');
			if ($client == "") {
				$client = "NONE";
			}
			if ($client != "NONE") {
				prh("Client Details", "desktop");
				//prn(getOrEmpty('SSL_CLIENT_S_DN_EMAIL'), "common name (cn)", 1);
				prn(getOrEmpty('CLIENT_CERT_DN'), "distinguished name (dn)", 0, 1);
				prn(getOrEmpty('CLIENT_CERT_SERIAL'), "serial");
				prn(getOrEmpty('CLIENT_CERT_FINGERPRINT'), "fingerprint");
				prn(getOrEmpty('CLIENT_CERT_V_START'), "cert valid from");
				prn(getOrEmpty('CLIENT_CERT_V_END'), "cert valid until");
				prn(getOrEmpty('CLIENT_CERT_V_REMAIN'), "cert days remaining");
				prn(getOrEmpty('CLIENT_CERT_VERIFY'), "client certificate verified");
				prn(getOrEmpty('CLIENT_CERT'), "client certificate", 0, 2);

				prn(getOrEmpty('REMOTE_USER'), "un");
				prf();
			}
			?>
		</div>
	</div>
</body>

</html>
<?php
function getOrEmpty(string $name) : string
{
	if (isset($_SERVER[$name])) {
		return $_SERVER[$name];
	} else {
		return "";
	}
}

function prn(string $var, string $desc, int $cls = 0, int $exp = 0, int $ignoreZero = 0)
{
	if ($ignoreZero == 1 && $var == "0") {
		$var = "";
	}
	if ($var != "") {
		$class = '';
		switch ($cls) {
			case 1:
				$class = " class='table-info'";
				break;
			case 2:
				$class = " class='table-success'";
				break;
		}
		if ($exp == 1) {
			$var = parseDn($var);
		}
		if ($exp == 2) {
			$var = urldecode($var);
			$var = "<pre>" . str_replace("\n","<br>", $var) . "</pre>";
		}
		echo "<tr$class><th scope='row' class='w-25'>$desc:</td><td class='w-75'>$var</td></tr>\n";
	}
}
function prh(string $title, string $ico = '')
{
	echo "<div class='col'><div class='card border-primary my-3'>
  <div class='card-header text-white bg-primary'>";
	if ($ico !== '') {
		echo "<span class='fas fa-$ico'></span> ";
	}
	echo "$title</div>
  <table class='table table-striped table-sm my-0'><tbody>";
}

function prf()
{
	echo "</tbody></table></div></div>";
}

function parseDn(string $dn)
{
	$parsr = explode(",", $dn);
	//$parsr=ldap_explode_dn($dn, 0);
	$out = "";
	foreach ($parsr as $key => $value) {
		if (FALSE !== strstr($value, '=')) {
			list($prefix, $data) = explode("=", $value);
			$out .= $prefix . " = " . $data . "<br/>";
		}
	}
	return $out;
}
