<?php

require_once('workoutdefinition.class.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/inc/config.php');
include_once($_SERVER['DOCUMENT_ROOT'] . '/inc/Ntfy.php');

use ApiMayerLife\Ntfy;

$debug = false;

if ($debug) {
	ini_set('display_errors', 1);
	error_reporting(E_ALL);
}

$txt_and = " und ";

$plans = array();
foreach ($config['workout'] as $workout) {
	$staticRep = null;
	$dynamicRep = null;
	if (is_array($workout['reps'])) {
		$tempReps = $workout['reps'];
		$dynamicRep = new WorkoutPlanPolynom($tempReps[0], $tempReps[1], $tempReps[2], $tempReps[3], $tempReps[4], $tempReps[5]);
	} else {
		$staticRep = $workout['reps'];
	}
	$plans[] = new WorkoutDefinition($workout['start'], $workout['desc'], new WorkoutInterval($workout['interval'], $workout['workout']), $staticRep, $dynamicRep);
}

if ($debug) {
	echo "<!DOCTYPE html><html><head><title>push</title></head><body>";
}

$todo = '';
$note = '';

$now = new DateTime();

foreach ($plans as $plan) {
	$curr = $plan->calculateFor($now);
	if ($curr) {
		if ($todo) {
			$todo .= $txt_and;
		}
		$todo .= $curr;
	}
}

if ($debug) {
	echo "<pre>" . $todo . "</pre>";
} else {
	if ($todo != '') {
		$ntfy = new Ntfy($config["ntfy-topic"], $config["ntfy-token"]);
		if ($ntfy->publish("Workout!", $todo, "cartwheeling")) {
			print "ok";
		} else {
			print "error publishing on ntfy.sh";
		}
	} else {
		print "ok";
	}
}
