<?php

class WorkoutPlanPolynom
{
	private $a;
	private $b;
	private $c;
	private $maxVal;
	private $maxAmt;

	public function __construct(
		int $startDayNum,
		int $startAmount,
		int $midDayNum,
		int $midAmount,
		int $endDayNum,
		int $endAmount,
	) {
		$matrix = array(
			array(pow($startDayNum, 2), $startDayNum, 1, $startAmount),
			array(pow($midDayNum, 2), $midDayNum, 1, $midAmount),
			array(pow($endDayNum, 2), $endDayNum, 1, $endAmount)
		);
		$this->maxVal = $endDayNum;
		$this->maxAmt = $endAmount;
		$denom = ($matrix[0][0] * $matrix[1][1] * $matrix[2][2]) +
			($matrix[0][1] * $matrix[1][2] * $matrix[2][0]) +
			($matrix[0][2] * $matrix[1][0] * $matrix[2][1]) -
			($matrix[0][2] * $matrix[1][1] * $matrix[2][0]) -
			($matrix[0][0] * $matrix[1][2] * $matrix[2][1]) -
			($matrix[0][1] * $matrix[1][0] * $matrix[2][2]);
		$anum = ($matrix[0][3] * $matrix[1][1] * $matrix[2][2]) +
			($matrix[0][1] * $matrix[1][2] * $matrix[2][3]) +
			($matrix[0][2] * $matrix[1][3] * $matrix[2][1]) -
			($matrix[0][2] * $matrix[1][1] * $matrix[2][3]) -
			($matrix[0][3] * $matrix[1][2] * $matrix[2][1]) -
			($matrix[0][1] * $matrix[1][3] * $matrix[2][2]);
		$bnum = ($matrix[0][0] * $matrix[1][3] * $matrix[2][2]) +
			($matrix[0][3] * $matrix[1][2] * $matrix[2][0]) +
			($matrix[0][2] * $matrix[1][0] * $matrix[2][3]) -
			($matrix[0][2] * $matrix[1][3] * $matrix[2][0]) -
			($matrix[0][0] * $matrix[1][2] * $matrix[2][3]) -
			($matrix[0][3] * $matrix[1][0] * $matrix[2][2]);
		$cnum = ($matrix[0][0] * $matrix[1][1] * $matrix[2][3]) +
			($matrix[0][1] * $matrix[1][3] * $matrix[2][0]) +
			($matrix[0][3] * $matrix[1][0] * $matrix[2][1]) -
			($matrix[0][3] * $matrix[1][1] * $matrix[2][0]) -
			($matrix[0][0] * $matrix[1][3] * $matrix[2][1]) -
			($matrix[0][1] * $matrix[1][0] * $matrix[2][3]);
		$this->a = $anum / $denom;
		$this->b = $bnum / $denom;
		$this->c = $cnum / $denom;
	}

	public function calc(int $dayNum)
	{
		if ($this->isPastEndDay($dayNum)) {
			return $this->maxAmt;
		}
		return round(($this->a * pow($dayNum, 2)) + ($this->b * $dayNum) + $this->c);
	}

	public function isPastEndDay(int $dayNum)
	{
		return ($dayNum >= $this->maxVal);
	}
}
